#ifndef _PCAP_H_
#define _PCAP_H_

#if defined(__cplusplus)
extern "C" {
#endif

#include "co_types.h"

typedef struct {
	uint32 magic;
	uint16 version_major;
	uint16 version_minor;
	uint32 thiszone;
	uint32 sigfigs;
	uint32 snaplen;
	uint32 linktype;
} PCapFileHdr_t;

typedef struct {
	struct timeval timestamp;
	uint32 length;
	uint32 onwireLength;
} PCapPktHdr_t;


int PCapRead_open( const char *filename);
int PCapRead_readPacket( uint8 *buf, uint32 size );
int PCapRead_close(void);

int PCapWrite_open( const char *filename);
int PCapWrite_writePacket( uint8 *buf, uint32 size );
int PCapWrite_close(void);


#if defined(__cplusplus)
}
#endif

#endif // _PCAP_H_
