/*********************************************************************
* Copyright (c) Impulse Accelerated Technologies, Inc.
* All Rights Reserved.
*/

#ifndef _SF_AV_ST_MAC_INTF_H_
#define _SF_AV_ST_MAC_INTF_H_

// field accessors
#define AV_ST_DATA_TYPE			co_uint256
#define AV_ST_SOP_TYPE			co_uint1
#define AV_ST_EOP_TYPE			co_uint1
#define AV_ST_EMPTY_TYPE		co_uint5
//#define AV_ST_ERROR_TYPE		co_uint1

#define AV_ST_DATA_WIDTH 		256
#define AV_ST_SOP_WIDTH			1
#define AV_ST_EOP_WIDTH			1
#define AV_ST_EMPTY_WIDTH		5
//#define AV_ST_ERROR_WIDTH		1

// Create typedefs for uncommon (not in co_math.h) co_[u]intN types.
// NOTE: In HDL they are n-bits, in SW sim they must be 32/64-bit CPU friendly
typedef uint32 co_uint263[9];

#define AV_ST_DATA_OFFSET  0
#define AV_ST_SOP_OFFSET   256
#define AV_ST_EOP_OFFSET   257
#define AV_ST_EMPTY_OFFSET 258
//#define AV_ST_ERROR_OFFSET  263

#define AV_ST_SET_FIELD(dst, val, field)  CO_BITS_PUT_U(dst, (val), AV_ST_##field##_OFFSET, AV_ST_##field##_WIDTH);
#define AV_ST_GET_FIELD(dst, val, field)  CO_BITS_GET_U(dst, (val), AV_ST_##field##_OFFSET, AV_ST_##field##_WIDTH);

/////
// raw stream in from Avalon-ST
// Note: Number of error bits is set to 6 because MAC Avalon-ST normally have 6, otherwise
//		  this can be set arbitrarily and an Avalon-ST Error Adapter could always be used
// Format: <Error[5:0]<Empty[2:0]><EOP><SOP><data[63:0]>
#define STREAM_RAW_MAC_DEPTH 	4
#ifdef IMPULSE_C_SYNTHESIS
#define STREAM_RAW_MAC_WIDTH 	(AV_ST_EMPTY_WIDTH+AV_ST_SOP_WIDTH+AV_ST_EOP_WIDTH+AV_ST_DATA_WIDTH) // 263
//#define STREAM_RAW_MAC_WIDTH 	(AV_ST_ERROR_WIDTH+AV_ST_EMPTY_WIDTH+AV_ST_SOP_WIDTH+AV_ST_EOP_WIDTH+AV_ST_DATA_WIDTH)
#else
#define STREAM_RAW_MAC_WIDTH	(sizeof(STREAM_RAW_MAC_TYPE)*8)
#endif
#define STREAM_RAW_MAC_TYPE		co_uint263  // type width must match stream's total width

#endif // _SF_AV_ST_MAC_INTF_H_
