/**************************************************************************\
 * *    Filename: ants_reg_access.h
 * * Description: ANTS low level access routines prototype
 * *
 * * Copyright (c) 2015-2016, Solarflare Communications Inc.
 * * All rights reserved.
 * *
 * * Redistribution and use in source and binary forms, with or without
 * * modification, are permitted provided that the following conditions are
 * * met:
 * *
 * * * Redistributions of source code must retain the above copyright notice,
 * *   this list of conditions and the following disclaimer.
 * *
 * * * Redistributions in binary form must reproduce the above copyright
 * *   notice, this list of conditions and the following disclaimer in the
 * *   documentation and/or other materials provided with the distribution.
 * *
 * * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * \**************************************************************************/

#include <ammlib.h>

#define ANTS_LOG_DEBUG printf

#define SF_HW_BLOCK_REG_WIDTH (sizeof(uint32_t))

amm_err_t ants_write_reg_block(amm_handle_t *handle, uint32_t  offset, uint32_t length, uint8_t  *data);

amm_err_t ants_write_reg(amm_handle_t handle, uint32_t address, uint32_t value);

amm_err_t ants_read_reg (amm_handle_t handle, uint32_t address, uint32_t *value);
