/*********************************************************************
* Copyright (c) 2012, Impulse Accelerated Technologies, Inc.
* All Rights Reserved.
*
* co_signal.c: Signal functions.
*
*********************************************************************/

#include "system.h"

#include <malloc.h>
#include <string.h>

#include "co.h"

co_signal co_signal_create(const char * name)
{
	co_signal signal = malloc(sizeof(co_signal_t));	
	if ( signal != NULL ) {
		signal->name = (name != NULL) ? strdup(name) : NULL;
		signal->direction = CO_NO_DIRECTION;
		signal->io = NULL;
	}
	return signal;
}

void co_signal_attach(co_signal signal, void * io, co_stream_direction dir)
{
	if ( signal != NULL ) {
	    signal->io = io;
    	signal->direction = dir;
    }
}

co_error co_signal_wait(co_signal signal, int32 * vp)
{
    if ( signal != NULL && vp != NULL ) {
        (void) nr_impc_read(vp, signal->io);
    }
    return co_err_none;
}

co_error co_signal_post(co_signal signal, int32 value)
{
    if ( signal != NULL ) {
        nr_impc_write(value, signal->io);
    }
    return co_err_none;
}


