# Copyright (c) 2012, Impulse Accelerated Technologies, Inc.
# All Rights Reserved.

####################
# files - added BEFORE identifying which is the top module for dependencies
add_file ../impulse_lib/avalon_if.vhd {SYNTHESIS SIMULATION}
add_file ../impulse_lib/cregister.vhd {SYNTHESIS SIMULATION}
add_file ../impulse_lib/csignal.vhd {SYNTHESIS SIMULATION}
add_file ../impulse_lib/divmod.vhd {SYNTHESIS SIMULATION}
add_file ../impulse_lib/fifo.vhd {SYNTHESIS SIMULATION}
add_file ../impulse_lib/fifo_dc.vhd {SYNTHESIS SIMULATION}
add_file ../impulse_lib/gmem.vhd {SYNTHESIS SIMULATION}
add_file ../impulse_lib/impack.vhd {SYNTHESIS SIMULATION}
add_file ../impulse_lib/mem_if.vhd {SYNTHESIS SIMULATION}
add_file ../impulse_lib/sema.vhd {SYNTHESIS SIMULATION}
add_file ../impulse_lib/stream.vhd {SYNTHESIS SIMULATION}
add_file ../impulse_lib/stream_dc.vhd {SYNTHESIS SIMULATION}
add_file ants_trigger_comp.vhd {SYNTHESIS SIMULATION}
add_file ants_trigger_top.vhd {SYNTHESIS SIMULATION}
add_file ants_trigger_arch_module.vhd {SYNTHESIS SIMULATION}
add_file ants_trigger_arch_module_header_block.vhd {SYNTHESIS SIMULATION}

####################
# module ants_trigger_arch_module
set_module_property NAME ants_trigger_arch_module
set_module_property VERSION 10.1
set_module_property GROUP "Impulse C Modules"
set_module_property DISPLAY_NAME "ants_trigger_arch module"
set_module_property LIBRARIES {ieee.std_logic_1164.all work.avalon_if.all std.standard.all}
set_module_property TOP_LEVEL_HDL_FILE ants_trigger_arch_module.vhd
set_module_property TOP_LEVEL_HDL_MODULE ants_trigger_arch_module
set_module_property INSTANTIATE_IN_SYSTEM_MODULE true
set_module_property EDITABLE false
set_module_property SIMULATION_MODEL_IS_OBFUSCATED false


####################
# user configurable parameters
add_parameter INCLUDE_HEADER_BLOCK Integer 0 
set_parameter_property INCLUDE_HEADER_BLOCK DISPLAY_NAME "Include the header block slave interface"
set_parameter_property INCLUDE_HEADER_BLOCK AFFECTS_ELABORATION true
set_parameter_property INCLUDE_HEADER_BLOCK DESCRIPTION "Include the header block slave interface"
set_parameter_property INCLUDE_HEADER_BLOCK DISPLAY_HINT boolean

# user configurable parameters for stream co_port mac_in_strm_port
# read-only display box for stream total width
add_parameter MAC_IN_STRM_PORT_STREAMTOTALBITS INTEGER 263
set_parameter_property MAC_IN_STRM_PORT_STREAMTOTALBITS GROUP MAC_IN_STRM_PORT_PARAMS
set_parameter_property MAC_IN_STRM_PORT_STREAMTOTALBITS ENABLED false
# entry box for stream symbols per beat
add_parameter MAC_IN_STRM_PORT_SYMBOLSPERBEAT INTEGER 32
set_parameter_property MAC_IN_STRM_PORT_SYMBOLSPERBEAT GROUP MAC_IN_STRM_PORT_PARAMS
# check box for symbol reversing data on Avalon-ST
add_parameter MAC_IN_STRM_PORT_REVERSESYMBOLSONAVST Integer 0
set_parameter_property MAC_IN_STRM_PORT_REVERSESYMBOLSONAVST GROUP MAC_IN_STRM_PORT_PARAMS
set_parameter_property MAC_IN_STRM_PORT_REVERSESYMBOLSONAVST DISPLAY_NAME "Reverse order of data symbols on the Avalon-ST port"
set_parameter_property MAC_IN_STRM_PORT_REVERSESYMBOLSONAVST DESCRIPTION "Reverse order of data symbols on the Avalon-ST port"
set_parameter_property MAC_IN_STRM_PORT_REVERSESYMBOLSONAVST DISPLAY_HINT boolean
set_parameter_property MAC_IN_STRM_PORT_REVERSESYMBOLSONAVST AFFECTS_ELABORATION true
# entry box for stream bits per symbol
add_parameter MAC_IN_STRM_PORT_DATABITSPERSYMBOL INTEGER 8
set_parameter_property MAC_IN_STRM_PORT_DATABITSPERSYMBOL GROUP MAC_IN_STRM_PORT_PARAMS
# check box for disabling start/end of packet bits on Avalon-ST
add_parameter MAC_IN_STRM_PORT_DISABLESOPEOPBITSONAVST Integer 0
set_parameter_property MAC_IN_STRM_PORT_DISABLESOPEOPBITSONAVST GROUP MAC_IN_STRM_PORT_PARAMS
set_parameter_property MAC_IN_STRM_PORT_DISABLESOPEOPBITSONAVST DISPLAY_NAME "Disable Start/End Of Packet (SOP/EOP) bits on the Avalon-ST port"
set_parameter_property MAC_IN_STRM_PORT_DISABLESOPEOPBITSONAVST DESCRIPTION "Disable Start/End Of Packet (SOP/EOP) bits on the Avalon-ST port"
set_parameter_property MAC_IN_STRM_PORT_DISABLESOPEOPBITSONAVST DISPLAY_HINT boolean
set_parameter_property MAC_IN_STRM_PORT_DISABLESOPEOPBITSONAVST AFFECTS_ELABORATION true
# check box for start/end of packet bits
add_parameter MAC_IN_STRM_PORT_SOPEOPBITSONSTREAM Integer 0
set_parameter_property MAC_IN_STRM_PORT_SOPEOPBITSONSTREAM GROUP MAC_IN_STRM_PORT_PARAMS
set_parameter_property MAC_IN_STRM_PORT_SOPEOPBITSONSTREAM DISPLAY_NAME "Include Start/End Of Packet (SOP/EOP) bits on the co_stream data port"
set_parameter_property MAC_IN_STRM_PORT_SOPEOPBITSONSTREAM DESCRIPTION "Include Start/End Of Packet (SOP/EOP) bits on the co_stream data port"
set_parameter_property MAC_IN_STRM_PORT_SOPEOPBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property MAC_IN_STRM_PORT_SOPEOPBITSONSTREAM AFFECTS_ELABORATION true
# entry box for error bits
add_parameter MAC_IN_STRM_PORT_NUMERRORBITS INTEGER 0
set_parameter_property MAC_IN_STRM_PORT_NUMERRORBITS GROUP MAC_IN_STRM_PORT_PARAMS
set_parameter_property MAC_IN_STRM_PORT_NUMERRORBITS AFFECTS_ELABORATION true
# check box for error bits
add_parameter MAC_IN_STRM_PORT_ERRORBITSONSTREAM Integer 0
set_parameter_property MAC_IN_STRM_PORT_ERRORBITSONSTREAM GROUP MAC_IN_STRM_PORT_PARAMS
set_parameter_property MAC_IN_STRM_PORT_ERRORBITSONSTREAM DISPLAY_NAME "Include error bits on the co_stream data port"
set_parameter_property MAC_IN_STRM_PORT_ERRORBITSONSTREAM DESCRIPTION "Include error bits on the co_stream data port"
set_parameter_property MAC_IN_STRM_PORT_ERRORBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property MAC_IN_STRM_PORT_ERRORBITSONSTREAM AFFECTS_ELABORATION true
# entry box for empty bits
add_parameter MAC_IN_STRM_PORT_NUMEMPTYBITS INTEGER 0
set_parameter_property MAC_IN_STRM_PORT_NUMEMPTYBITS GROUP MAC_IN_STRM_PORT_PARAMS
set_parameter_property MAC_IN_STRM_PORT_NUMEMPTYBITS AFFECTS_ELABORATION true
# check box for empty bits
add_parameter MAC_IN_STRM_PORT_EMPTYBITSONSTREAM Integer 0
set_parameter_property MAC_IN_STRM_PORT_EMPTYBITSONSTREAM GROUP MAC_IN_STRM_PORT_PARAMS
set_parameter_property MAC_IN_STRM_PORT_EMPTYBITSONSTREAM DISPLAY_NAME "Include empty bits on the co_stream data port"
set_parameter_property MAC_IN_STRM_PORT_EMPTYBITSONSTREAM DESCRIPTION "Include empty bits on the co_stream data port"
set_parameter_property MAC_IN_STRM_PORT_EMPTYBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property MAC_IN_STRM_PORT_EMPTYBITSONSTREAM AFFECTS_ELABORATION true


# user configurable parameters for stream co_port mac_out_strm_port
# read-only display box for stream total width
add_parameter MAC_OUT_STRM_PORT_STREAMTOTALBITS INTEGER 263
set_parameter_property MAC_OUT_STRM_PORT_STREAMTOTALBITS GROUP MAC_OUT_STRM_PORT_PARAMS
set_parameter_property MAC_OUT_STRM_PORT_STREAMTOTALBITS ENABLED false
# entry box for stream symbols per beat
add_parameter MAC_OUT_STRM_PORT_SYMBOLSPERBEAT INTEGER 32
set_parameter_property MAC_OUT_STRM_PORT_SYMBOLSPERBEAT GROUP MAC_OUT_STRM_PORT_PARAMS
# check box for symbol reversing data on Avalon-ST
add_parameter MAC_OUT_STRM_PORT_REVERSESYMBOLSONAVST Integer 0
set_parameter_property MAC_OUT_STRM_PORT_REVERSESYMBOLSONAVST GROUP MAC_OUT_STRM_PORT_PARAMS
set_parameter_property MAC_OUT_STRM_PORT_REVERSESYMBOLSONAVST DISPLAY_NAME "Reverse order of data symbols on the Avalon-ST port"
set_parameter_property MAC_OUT_STRM_PORT_REVERSESYMBOLSONAVST DESCRIPTION "Reverse order of data symbols on the Avalon-ST port"
set_parameter_property MAC_OUT_STRM_PORT_REVERSESYMBOLSONAVST DISPLAY_HINT boolean
set_parameter_property MAC_OUT_STRM_PORT_REVERSESYMBOLSONAVST AFFECTS_ELABORATION true
# entry box for stream bits per symbol
add_parameter MAC_OUT_STRM_PORT_DATABITSPERSYMBOL INTEGER 8
set_parameter_property MAC_OUT_STRM_PORT_DATABITSPERSYMBOL GROUP MAC_OUT_STRM_PORT_PARAMS
# check box for disabling start/end of packet bits on Avalon-ST
add_parameter MAC_OUT_STRM_PORT_DISABLESOPEOPBITSONAVST Integer 0
set_parameter_property MAC_OUT_STRM_PORT_DISABLESOPEOPBITSONAVST GROUP MAC_OUT_STRM_PORT_PARAMS
set_parameter_property MAC_OUT_STRM_PORT_DISABLESOPEOPBITSONAVST DISPLAY_NAME "Disable Start/End Of Packet (SOP/EOP) bits on the Avalon-ST port"
set_parameter_property MAC_OUT_STRM_PORT_DISABLESOPEOPBITSONAVST DESCRIPTION "Disable Start/End Of Packet (SOP/EOP) bits on the Avalon-ST port"
set_parameter_property MAC_OUT_STRM_PORT_DISABLESOPEOPBITSONAVST DISPLAY_HINT boolean
set_parameter_property MAC_OUT_STRM_PORT_DISABLESOPEOPBITSONAVST AFFECTS_ELABORATION true
# check box for start/end of packet bits
add_parameter MAC_OUT_STRM_PORT_SOPEOPBITSONSTREAM Integer 0
set_parameter_property MAC_OUT_STRM_PORT_SOPEOPBITSONSTREAM GROUP MAC_OUT_STRM_PORT_PARAMS
set_parameter_property MAC_OUT_STRM_PORT_SOPEOPBITSONSTREAM DISPLAY_NAME "Include Start/End Of Packet (SOP/EOP) bits on the co_stream data port"
set_parameter_property MAC_OUT_STRM_PORT_SOPEOPBITSONSTREAM DESCRIPTION "Include Start/End Of Packet (SOP/EOP) bits on the co_stream data port"
set_parameter_property MAC_OUT_STRM_PORT_SOPEOPBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property MAC_OUT_STRM_PORT_SOPEOPBITSONSTREAM AFFECTS_ELABORATION true
# entry box for error bits
add_parameter MAC_OUT_STRM_PORT_NUMERRORBITS INTEGER 0
set_parameter_property MAC_OUT_STRM_PORT_NUMERRORBITS GROUP MAC_OUT_STRM_PORT_PARAMS
set_parameter_property MAC_OUT_STRM_PORT_NUMERRORBITS AFFECTS_ELABORATION true
# check box for error bits
add_parameter MAC_OUT_STRM_PORT_ERRORBITSONSTREAM Integer 0
set_parameter_property MAC_OUT_STRM_PORT_ERRORBITSONSTREAM GROUP MAC_OUT_STRM_PORT_PARAMS
set_parameter_property MAC_OUT_STRM_PORT_ERRORBITSONSTREAM DISPLAY_NAME "Include error bits on the co_stream data port"
set_parameter_property MAC_OUT_STRM_PORT_ERRORBITSONSTREAM DESCRIPTION "Include error bits on the co_stream data port"
set_parameter_property MAC_OUT_STRM_PORT_ERRORBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property MAC_OUT_STRM_PORT_ERRORBITSONSTREAM AFFECTS_ELABORATION true
# entry box for empty bits
add_parameter MAC_OUT_STRM_PORT_NUMEMPTYBITS INTEGER 0
set_parameter_property MAC_OUT_STRM_PORT_NUMEMPTYBITS GROUP MAC_OUT_STRM_PORT_PARAMS
set_parameter_property MAC_OUT_STRM_PORT_NUMEMPTYBITS AFFECTS_ELABORATION true
# check box for empty bits
add_parameter MAC_OUT_STRM_PORT_EMPTYBITSONSTREAM Integer 0
set_parameter_property MAC_OUT_STRM_PORT_EMPTYBITSONSTREAM GROUP MAC_OUT_STRM_PORT_PARAMS
set_parameter_property MAC_OUT_STRM_PORT_EMPTYBITSONSTREAM DISPLAY_NAME "Include empty bits on the co_stream data port"
set_parameter_property MAC_OUT_STRM_PORT_EMPTYBITSONSTREAM DESCRIPTION "Include empty bits on the co_stream data port"
set_parameter_property MAC_OUT_STRM_PORT_EMPTYBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property MAC_OUT_STRM_PORT_EMPTYBITSONSTREAM AFFECTS_ELABORATION true


# user configurable parameters for stream co_port command_strm_port
# read-only display box for stream total width
add_parameter COMMAND_STRM_PORT_STREAMTOTALBITS INTEGER 32
set_parameter_property COMMAND_STRM_PORT_STREAMTOTALBITS GROUP COMMAND_STRM_PORT_PARAMS
set_parameter_property COMMAND_STRM_PORT_STREAMTOTALBITS ENABLED false
# entry box for stream symbols per beat
add_parameter COMMAND_STRM_PORT_SYMBOLSPERBEAT INTEGER 4
set_parameter_property COMMAND_STRM_PORT_SYMBOLSPERBEAT GROUP COMMAND_STRM_PORT_PARAMS
# check box for symbol reversing data on Avalon-ST
add_parameter COMMAND_STRM_PORT_REVERSESYMBOLSONAVST Integer 0
set_parameter_property COMMAND_STRM_PORT_REVERSESYMBOLSONAVST GROUP COMMAND_STRM_PORT_PARAMS
set_parameter_property COMMAND_STRM_PORT_REVERSESYMBOLSONAVST DISPLAY_NAME "Reverse order of data symbols on the Avalon-ST port"
set_parameter_property COMMAND_STRM_PORT_REVERSESYMBOLSONAVST DESCRIPTION "Reverse order of data symbols on the Avalon-ST port"
set_parameter_property COMMAND_STRM_PORT_REVERSESYMBOLSONAVST DISPLAY_HINT boolean
set_parameter_property COMMAND_STRM_PORT_REVERSESYMBOLSONAVST AFFECTS_ELABORATION true
# entry box for stream bits per symbol
add_parameter COMMAND_STRM_PORT_DATABITSPERSYMBOL INTEGER 8
set_parameter_property COMMAND_STRM_PORT_DATABITSPERSYMBOL GROUP COMMAND_STRM_PORT_PARAMS
# check box for disabling start/end of packet bits on Avalon-ST
add_parameter COMMAND_STRM_PORT_DISABLESOPEOPBITSONAVST Integer 0
set_parameter_property COMMAND_STRM_PORT_DISABLESOPEOPBITSONAVST GROUP COMMAND_STRM_PORT_PARAMS
set_parameter_property COMMAND_STRM_PORT_DISABLESOPEOPBITSONAVST DISPLAY_NAME "Disable Start/End Of Packet (SOP/EOP) bits on the Avalon-ST port"
set_parameter_property COMMAND_STRM_PORT_DISABLESOPEOPBITSONAVST DESCRIPTION "Disable Start/End Of Packet (SOP/EOP) bits on the Avalon-ST port"
set_parameter_property COMMAND_STRM_PORT_DISABLESOPEOPBITSONAVST DISPLAY_HINT boolean
set_parameter_property COMMAND_STRM_PORT_DISABLESOPEOPBITSONAVST AFFECTS_ELABORATION true
# check box for start/end of packet bits
add_parameter COMMAND_STRM_PORT_SOPEOPBITSONSTREAM Integer 0
set_parameter_property COMMAND_STRM_PORT_SOPEOPBITSONSTREAM GROUP COMMAND_STRM_PORT_PARAMS
set_parameter_property COMMAND_STRM_PORT_SOPEOPBITSONSTREAM DISPLAY_NAME "Include Start/End Of Packet (SOP/EOP) bits on the co_stream data port"
set_parameter_property COMMAND_STRM_PORT_SOPEOPBITSONSTREAM DESCRIPTION "Include Start/End Of Packet (SOP/EOP) bits on the co_stream data port"
set_parameter_property COMMAND_STRM_PORT_SOPEOPBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property COMMAND_STRM_PORT_SOPEOPBITSONSTREAM AFFECTS_ELABORATION true
# entry box for error bits
add_parameter COMMAND_STRM_PORT_NUMERRORBITS INTEGER 0
set_parameter_property COMMAND_STRM_PORT_NUMERRORBITS GROUP COMMAND_STRM_PORT_PARAMS
set_parameter_property COMMAND_STRM_PORT_NUMERRORBITS AFFECTS_ELABORATION true
# check box for error bits
add_parameter COMMAND_STRM_PORT_ERRORBITSONSTREAM Integer 0
set_parameter_property COMMAND_STRM_PORT_ERRORBITSONSTREAM GROUP COMMAND_STRM_PORT_PARAMS
set_parameter_property COMMAND_STRM_PORT_ERRORBITSONSTREAM DISPLAY_NAME "Include error bits on the co_stream data port"
set_parameter_property COMMAND_STRM_PORT_ERRORBITSONSTREAM DESCRIPTION "Include error bits on the co_stream data port"
set_parameter_property COMMAND_STRM_PORT_ERRORBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property COMMAND_STRM_PORT_ERRORBITSONSTREAM AFFECTS_ELABORATION true
# entry box for empty bits
add_parameter COMMAND_STRM_PORT_NUMEMPTYBITS INTEGER 0
set_parameter_property COMMAND_STRM_PORT_NUMEMPTYBITS GROUP COMMAND_STRM_PORT_PARAMS
set_parameter_property COMMAND_STRM_PORT_NUMEMPTYBITS AFFECTS_ELABORATION true
# check box for empty bits
add_parameter COMMAND_STRM_PORT_EMPTYBITSONSTREAM Integer 0
set_parameter_property COMMAND_STRM_PORT_EMPTYBITSONSTREAM GROUP COMMAND_STRM_PORT_PARAMS
set_parameter_property COMMAND_STRM_PORT_EMPTYBITSONSTREAM DISPLAY_NAME "Include empty bits on the co_stream data port"
set_parameter_property COMMAND_STRM_PORT_EMPTYBITSONSTREAM DESCRIPTION "Include empty bits on the co_stream data port"
set_parameter_property COMMAND_STRM_PORT_EMPTYBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property COMMAND_STRM_PORT_EMPTYBITSONSTREAM AFFECTS_ELABORATION true


# user configurable parameters for stream co_port status_strm_port
# read-only display box for stream total width
add_parameter STATUS_STRM_PORT_STREAMTOTALBITS INTEGER 32
set_parameter_property STATUS_STRM_PORT_STREAMTOTALBITS GROUP STATUS_STRM_PORT_PARAMS
set_parameter_property STATUS_STRM_PORT_STREAMTOTALBITS ENABLED false
# entry box for stream symbols per beat
add_parameter STATUS_STRM_PORT_SYMBOLSPERBEAT INTEGER 4
set_parameter_property STATUS_STRM_PORT_SYMBOLSPERBEAT GROUP STATUS_STRM_PORT_PARAMS
# check box for symbol reversing data on Avalon-ST
add_parameter STATUS_STRM_PORT_REVERSESYMBOLSONAVST Integer 0
set_parameter_property STATUS_STRM_PORT_REVERSESYMBOLSONAVST GROUP STATUS_STRM_PORT_PARAMS
set_parameter_property STATUS_STRM_PORT_REVERSESYMBOLSONAVST DISPLAY_NAME "Reverse order of data symbols on the Avalon-ST port"
set_parameter_property STATUS_STRM_PORT_REVERSESYMBOLSONAVST DESCRIPTION "Reverse order of data symbols on the Avalon-ST port"
set_parameter_property STATUS_STRM_PORT_REVERSESYMBOLSONAVST DISPLAY_HINT boolean
set_parameter_property STATUS_STRM_PORT_REVERSESYMBOLSONAVST AFFECTS_ELABORATION true
# entry box for stream bits per symbol
add_parameter STATUS_STRM_PORT_DATABITSPERSYMBOL INTEGER 8
set_parameter_property STATUS_STRM_PORT_DATABITSPERSYMBOL GROUP STATUS_STRM_PORT_PARAMS
# check box for disabling start/end of packet bits on Avalon-ST
add_parameter STATUS_STRM_PORT_DISABLESOPEOPBITSONAVST Integer 0
set_parameter_property STATUS_STRM_PORT_DISABLESOPEOPBITSONAVST GROUP STATUS_STRM_PORT_PARAMS
set_parameter_property STATUS_STRM_PORT_DISABLESOPEOPBITSONAVST DISPLAY_NAME "Disable Start/End Of Packet (SOP/EOP) bits on the Avalon-ST port"
set_parameter_property STATUS_STRM_PORT_DISABLESOPEOPBITSONAVST DESCRIPTION "Disable Start/End Of Packet (SOP/EOP) bits on the Avalon-ST port"
set_parameter_property STATUS_STRM_PORT_DISABLESOPEOPBITSONAVST DISPLAY_HINT boolean
set_parameter_property STATUS_STRM_PORT_DISABLESOPEOPBITSONAVST AFFECTS_ELABORATION true
# check box for start/end of packet bits
add_parameter STATUS_STRM_PORT_SOPEOPBITSONSTREAM Integer 0
set_parameter_property STATUS_STRM_PORT_SOPEOPBITSONSTREAM GROUP STATUS_STRM_PORT_PARAMS
set_parameter_property STATUS_STRM_PORT_SOPEOPBITSONSTREAM DISPLAY_NAME "Include Start/End Of Packet (SOP/EOP) bits on the co_stream data port"
set_parameter_property STATUS_STRM_PORT_SOPEOPBITSONSTREAM DESCRIPTION "Include Start/End Of Packet (SOP/EOP) bits on the co_stream data port"
set_parameter_property STATUS_STRM_PORT_SOPEOPBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property STATUS_STRM_PORT_SOPEOPBITSONSTREAM AFFECTS_ELABORATION true
# entry box for error bits
add_parameter STATUS_STRM_PORT_NUMERRORBITS INTEGER 0
set_parameter_property STATUS_STRM_PORT_NUMERRORBITS GROUP STATUS_STRM_PORT_PARAMS
set_parameter_property STATUS_STRM_PORT_NUMERRORBITS AFFECTS_ELABORATION true
# check box for error bits
add_parameter STATUS_STRM_PORT_ERRORBITSONSTREAM Integer 0
set_parameter_property STATUS_STRM_PORT_ERRORBITSONSTREAM GROUP STATUS_STRM_PORT_PARAMS
set_parameter_property STATUS_STRM_PORT_ERRORBITSONSTREAM DISPLAY_NAME "Include error bits on the co_stream data port"
set_parameter_property STATUS_STRM_PORT_ERRORBITSONSTREAM DESCRIPTION "Include error bits on the co_stream data port"
set_parameter_property STATUS_STRM_PORT_ERRORBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property STATUS_STRM_PORT_ERRORBITSONSTREAM AFFECTS_ELABORATION true
# entry box for empty bits
add_parameter STATUS_STRM_PORT_NUMEMPTYBITS INTEGER 0
set_parameter_property STATUS_STRM_PORT_NUMEMPTYBITS GROUP STATUS_STRM_PORT_PARAMS
set_parameter_property STATUS_STRM_PORT_NUMEMPTYBITS AFFECTS_ELABORATION true
# check box for empty bits
add_parameter STATUS_STRM_PORT_EMPTYBITSONSTREAM Integer 0
set_parameter_property STATUS_STRM_PORT_EMPTYBITSONSTREAM GROUP STATUS_STRM_PORT_PARAMS
set_parameter_property STATUS_STRM_PORT_EMPTYBITSONSTREAM DISPLAY_NAME "Include empty bits on the co_stream data port"
set_parameter_property STATUS_STRM_PORT_EMPTYBITSONSTREAM DESCRIPTION "Include empty bits on the co_stream data port"
set_parameter_property STATUS_STRM_PORT_EMPTYBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property STATUS_STRM_PORT_EMPTYBITSONSTREAM AFFECTS_ELABORATION true


# user configurable parameters for stream co_port trigger_strm_port
# read-only display box for stream total width
add_parameter TRIGGER_STRM_PORT_STREAMTOTALBITS INTEGER 48
set_parameter_property TRIGGER_STRM_PORT_STREAMTOTALBITS GROUP TRIGGER_STRM_PORT_PARAMS
set_parameter_property TRIGGER_STRM_PORT_STREAMTOTALBITS ENABLED false
# entry box for stream symbols per beat
add_parameter TRIGGER_STRM_PORT_SYMBOLSPERBEAT INTEGER 6
set_parameter_property TRIGGER_STRM_PORT_SYMBOLSPERBEAT GROUP TRIGGER_STRM_PORT_PARAMS
# check box for symbol reversing data on Avalon-ST
add_parameter TRIGGER_STRM_PORT_REVERSESYMBOLSONAVST Integer 0
set_parameter_property TRIGGER_STRM_PORT_REVERSESYMBOLSONAVST GROUP TRIGGER_STRM_PORT_PARAMS
set_parameter_property TRIGGER_STRM_PORT_REVERSESYMBOLSONAVST DISPLAY_NAME "Reverse order of data symbols on the Avalon-ST port"
set_parameter_property TRIGGER_STRM_PORT_REVERSESYMBOLSONAVST DESCRIPTION "Reverse order of data symbols on the Avalon-ST port"
set_parameter_property TRIGGER_STRM_PORT_REVERSESYMBOLSONAVST DISPLAY_HINT boolean
set_parameter_property TRIGGER_STRM_PORT_REVERSESYMBOLSONAVST AFFECTS_ELABORATION true
# entry box for stream bits per symbol
add_parameter TRIGGER_STRM_PORT_DATABITSPERSYMBOL INTEGER 8
set_parameter_property TRIGGER_STRM_PORT_DATABITSPERSYMBOL GROUP TRIGGER_STRM_PORT_PARAMS
# check box for disabling start/end of packet bits on Avalon-ST
add_parameter TRIGGER_STRM_PORT_DISABLESOPEOPBITSONAVST Integer 0
set_parameter_property TRIGGER_STRM_PORT_DISABLESOPEOPBITSONAVST GROUP TRIGGER_STRM_PORT_PARAMS
set_parameter_property TRIGGER_STRM_PORT_DISABLESOPEOPBITSONAVST DISPLAY_NAME "Disable Start/End Of Packet (SOP/EOP) bits on the Avalon-ST port"
set_parameter_property TRIGGER_STRM_PORT_DISABLESOPEOPBITSONAVST DESCRIPTION "Disable Start/End Of Packet (SOP/EOP) bits on the Avalon-ST port"
set_parameter_property TRIGGER_STRM_PORT_DISABLESOPEOPBITSONAVST DISPLAY_HINT boolean
set_parameter_property TRIGGER_STRM_PORT_DISABLESOPEOPBITSONAVST AFFECTS_ELABORATION true
# check box for start/end of packet bits
add_parameter TRIGGER_STRM_PORT_SOPEOPBITSONSTREAM Integer 0
set_parameter_property TRIGGER_STRM_PORT_SOPEOPBITSONSTREAM GROUP TRIGGER_STRM_PORT_PARAMS
set_parameter_property TRIGGER_STRM_PORT_SOPEOPBITSONSTREAM DISPLAY_NAME "Include Start/End Of Packet (SOP/EOP) bits on the co_stream data port"
set_parameter_property TRIGGER_STRM_PORT_SOPEOPBITSONSTREAM DESCRIPTION "Include Start/End Of Packet (SOP/EOP) bits on the co_stream data port"
set_parameter_property TRIGGER_STRM_PORT_SOPEOPBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property TRIGGER_STRM_PORT_SOPEOPBITSONSTREAM AFFECTS_ELABORATION true
# entry box for error bits
add_parameter TRIGGER_STRM_PORT_NUMERRORBITS INTEGER 0
set_parameter_property TRIGGER_STRM_PORT_NUMERRORBITS GROUP TRIGGER_STRM_PORT_PARAMS
set_parameter_property TRIGGER_STRM_PORT_NUMERRORBITS AFFECTS_ELABORATION true
# check box for error bits
add_parameter TRIGGER_STRM_PORT_ERRORBITSONSTREAM Integer 0
set_parameter_property TRIGGER_STRM_PORT_ERRORBITSONSTREAM GROUP TRIGGER_STRM_PORT_PARAMS
set_parameter_property TRIGGER_STRM_PORT_ERRORBITSONSTREAM DISPLAY_NAME "Include error bits on the co_stream data port"
set_parameter_property TRIGGER_STRM_PORT_ERRORBITSONSTREAM DESCRIPTION "Include error bits on the co_stream data port"
set_parameter_property TRIGGER_STRM_PORT_ERRORBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property TRIGGER_STRM_PORT_ERRORBITSONSTREAM AFFECTS_ELABORATION true
# entry box for empty bits
add_parameter TRIGGER_STRM_PORT_NUMEMPTYBITS INTEGER 0
set_parameter_property TRIGGER_STRM_PORT_NUMEMPTYBITS GROUP TRIGGER_STRM_PORT_PARAMS
set_parameter_property TRIGGER_STRM_PORT_NUMEMPTYBITS AFFECTS_ELABORATION true
# check box for empty bits
add_parameter TRIGGER_STRM_PORT_EMPTYBITSONSTREAM Integer 0
set_parameter_property TRIGGER_STRM_PORT_EMPTYBITSONSTREAM GROUP TRIGGER_STRM_PORT_PARAMS
set_parameter_property TRIGGER_STRM_PORT_EMPTYBITSONSTREAM DISPLAY_NAME "Include empty bits on the co_stream data port"
set_parameter_property TRIGGER_STRM_PORT_EMPTYBITSONSTREAM DESCRIPTION "Include empty bits on the co_stream data port"
set_parameter_property TRIGGER_STRM_PORT_EMPTYBITSONSTREAM DISPLAY_HINT boolean
set_parameter_property TRIGGER_STRM_PORT_EMPTYBITSONSTREAM AFFECTS_ELABORATION true


####################
# callbacks
set_module_property ELABORATION_CALLBACK elaborate
set_module_property VALIDATION_CALLBACK  validate
set_module_property GENERATION_CALLBACK generate

####################
# connection point for clock and reset
add_interface clk clock end
set_interface_property clk ptfSchematicName ""

add_interface_port clk clk clk Input 1
add_interface_port clk reset reset Input 1

# Wire Interface global_signals_export
#add_interface global_signals_export conduit input global_signals_clock
#add_interface_port global_signals_export co_clk export
#add_interface_port global_signals_export co_reset export

####################
# validation callback
proc validate { } {
	send_message info "validate: BEGIN"
	send_message info "validate: INCLUDE_HEADER_BLOCK = [get_parameter_value INCLUDE_HEADER_BLOCK]"
	foreach param [get_parameters] {
		if { [regexp {(.*)_STREAMTOTALBITS} $param match streamName] } {
   		# calculate number of bits connected to each stream and report status
      	set intfNameUpper [string toupper $streamName]
      	set totalBits [get_parameter_value ${intfNameUpper}_STREAMTOTALBITS]
      	set totalBits [expr $totalBits - [get_parameter_value ${intfNameUpper}_SYMBOLSPERBEAT] * [get_parameter_value ${intfNameUpper}_DATABITSPERSYMBOL]]
			set numErrorBits [get_parameter_value ${intfNameUpper}_NUMERRORBITS]
			set numEmptyBits [get_parameter_value ${intfNameUpper}_NUMEMPTYBITS]

         if { [get_parameter_value ${intfNameUpper}_SOPEOPBITSONSTREAM] != 0} {
            set_parameter_property ${intfNameUpper}_DISABLESOPEOPBITSONAVST ENABLED false
				# only add EOP or SOP if not disabled on Avalon-ST
      		if { [get_parameter_value ${intfNameUpper}_DISABLESOPEOPBITSONAVST] == 0} {
           		set totalBits [expr $totalBits - 2]
         }
         } else {
				set_parameter_property ${intfNameUpper}_DISABLESOPEOPBITSONAVST ENABLED true
				if { [get_parameter_value ${intfNameUpper}_DISABLESOPEOPBITSONAVST] != 0} {
					set_parameter_property ${intfNameUpper}_SOPEOPBITSONSTREAM ENABLED false 
				} else {
					set_parameter_property ${intfNameUpper}_SOPEOPBITSONSTREAM ENABLED true
				}
         }
      	if { [get_parameter_value ${intfNameUpper}_ERRORBITSONSTREAM] != 0} {
				set totalBits [expr $totalBits - $numErrorBits]
				if {$numErrorBits < 1} {
					send_message error "validate: ${intfNameUpper} ${intfNameUpper}_NUMERRORBITS must be set to >0 to include error bits on co_stream data port"
				}
      	} else {
      		send_message warning "validate: ${intfNameUpper} error bits, if present, are not connected to stream and will be ignored(input) or set to 0's(output).  Total bits [get_parameter_value [string toupper ${intfNameUpper}]_NUMERRORBITS]"
      	}

      	if { [get_parameter_value ${intfNameUpper}_EMPTYBITSONSTREAM] != 0} {
      		set totalBits [expr $totalBits - $numEmptyBits]
				if {$numEmptyBits < 1} {
					send_message error "validate: ${intfNameUpper} ${intfNameUpper}_NUMEMPTYBITS must be set to >0 to include empty bits on co_stream data port"
				}
      	} else {
      		send_message warning "validate: ${intfNameUpper} empty bits, if present, are not connected to stream and will be ignored(input) or set to 0's(output).  Total bits [get_parameter_value [string toupper ${intfNameUpper}]_NUMEMPTYBITS]"
      	}
      	if { $totalBits != 0 } {
      		send_message error "validate: !! Stream ${intfNameUpper} has incorrect number of bits assigned which must be equal to ${intfNameUpper}_STREAMTOTALBITS, calculation:"
      		send_message error "validate: !!   		${intfNameUpper}_SYMBOLSPERBEAT * ${intfNameUpper}_DATABITSPERSYMBOL +"
      		send_message error "validate: !!       (if included)2 if ${intfNameUpper}_SOPEOPBITSONSTREAM is checked and ${intfNameUpper}_DISABLESOPEOPBITSONAVST is false+"
      		send_message error "validate: !!      	(if included)${intfNameUpper}_NUMERRORBITS +"
      		send_message error "validate: !!      	(if included)${intfNameUpper}_NUMEMPTYBITS"
      	}
		}
	}
	
	send_message info "validate: END"
}

####################
# elaboration callback
proc elaborate { } {
	send_message info "elaborate: BEGIN"
	####################
	# slave avalon connection point for header if enabled
	if {[get_parameter_value INCLUDE_HEADER_BLOCK] == 1} {
		add_interface header_block avalon end
		set_interface_property header_block holdTime 0
		set_interface_property header_block linewrapBursts false
		set_interface_property header_block burstOnBurstBoundariesOnly false
		set_interface_property header_block timingUnits Cycles
		set_interface_property header_block setupTime 0
		set_interface_property header_block writeWaitTime 0
		set_interface_property header_block maximumPendingReadTransactions 0
		set_interface_property header_block readWaitTime 0
		set_interface_property header_block readLatency 0
		
		set_interface_property header_block associatedClock clk
		
		add_interface_port header_block header_block_addr address Input 2
		add_interface_port header_block header_block_write_n write_n Input 1
		add_interface_port header_block header_block_read_n read_n Input 1
		add_interface_port header_block header_block_wdata writedata Input 64
		add_interface_port header_block header_block_rdata readdata Output 64
		add_interface_port header_block header_block_ce chipselect Input 1
	} else {
		# Don't add any interface or ports that isn't actually conencted to
		#  the top entity in order to avoid warnings in SOPC builder that:
		#		"Port XXX in Tcl description is not found in the design file"
	}

####################
# interface connections

   ####################
   # Avalon-ST Packet connection point for stream co_port mac_in_strm_port for bustype avalon_st_raw
   add_interface mac_in_strm_port avalon_streaming sink clk
   set_interface_property mac_in_strm_port symbolsPerBeat [get_parameter_value MAC_IN_STRM_PORT_SYMBOLSPERBEAT ]
   set_interface_property mac_in_strm_port dataBitsPerSymbol [get_parameter_value MAC_IN_STRM_PORT_DATABITSPERSYMBOL ]
   
   set_interface_property mac_in_strm_port associatedClock clk
   
   add_interface_port mac_in_strm_port mac_in_strm_port_ready ready Output 1
   add_interface_port mac_in_strm_port mac_in_strm_port_valid valid Input 1
   add_interface_port mac_in_strm_port mac_in_strm_port_data data Input [expr [get_parameter_value MAC_IN_STRM_PORT_SYMBOLSPERBEAT ] * [get_parameter_value MAC_IN_STRM_PORT_DATABITSPERSYMBOL ]]
	if { [get_parameter_value [string toupper mac_in_strm_port]_DISABLESOPEOPBITSONAVST] == 0} {
      add_interface_port mac_in_strm_port mac_in_strm_port_endofpacket endofpacket Input 1
      add_interface_port mac_in_strm_port mac_in_strm_port_startofpacket startofpacket Input 1
   }


	set numErrBits [get_parameter_value [string toupper mac_in_strm_port]_NUMERRORBITS] 
   if {$numErrBits > 0} {
		add_interface_port mac_in_strm_port mac_in_strm_port_error error Input $numErrBits
   }
	set numEmptyBits [get_parameter_value [string toupper mac_in_strm_port]_NUMEMPTYBITS] 
	if {$numEmptyBits > 0} {
		add_interface_port mac_in_strm_port mac_in_strm_port_empty empty Input $numEmptyBits
	}


   ####################
   # Avalon-ST Packet connection point for stream co_port mac_out_strm_port for bustype avalon_st_raw
   add_interface mac_out_strm_port avalon_streaming source clk
   set_interface_property mac_out_strm_port symbolsPerBeat [get_parameter_value MAC_OUT_STRM_PORT_SYMBOLSPERBEAT ]
   set_interface_property mac_out_strm_port dataBitsPerSymbol [get_parameter_value MAC_OUT_STRM_PORT_DATABITSPERSYMBOL ]
   
   set_interface_property mac_out_strm_port associatedClock clk
   
   add_interface_port mac_out_strm_port mac_out_strm_port_ready ready Input 1
   add_interface_port mac_out_strm_port mac_out_strm_port_valid valid Output 1
   add_interface_port mac_out_strm_port mac_out_strm_port_data data Output [expr [get_parameter_value MAC_OUT_STRM_PORT_SYMBOLSPERBEAT ] * [get_parameter_value MAC_OUT_STRM_PORT_DATABITSPERSYMBOL ]]
	if { [get_parameter_value [string toupper mac_out_strm_port]_DISABLESOPEOPBITSONAVST] == 0} {
      add_interface_port mac_out_strm_port mac_out_strm_port_endofpacket endofpacket Output 1
      add_interface_port mac_out_strm_port mac_out_strm_port_startofpacket startofpacket Output 1
   }


	set numErrBits [get_parameter_value [string toupper mac_out_strm_port]_NUMERRORBITS] 
	if {$numErrBits > 0} {
		add_interface_port mac_out_strm_port mac_out_strm_port_error error Output $numErrBits
	}
	set numEmptyBits [get_parameter_value [string toupper mac_out_strm_port]_NUMEMPTYBITS] 
	if {$numEmptyBits > 0} {
		add_interface_port mac_out_strm_port mac_out_strm_port_empty empty Output $numEmptyBits
	}


   ####################
   # Avalon-ST Packet connection point for stream co_port command_strm_port for bustype avalon_st_raw
   add_interface command_strm_port avalon_streaming sink clk
   set_interface_property command_strm_port symbolsPerBeat [get_parameter_value COMMAND_STRM_PORT_SYMBOLSPERBEAT ]
   set_interface_property command_strm_port dataBitsPerSymbol [get_parameter_value COMMAND_STRM_PORT_DATABITSPERSYMBOL ]
   
   set_interface_property command_strm_port associatedClock clk
   
   add_interface_port command_strm_port command_strm_port_ready ready Output 1
   add_interface_port command_strm_port command_strm_port_valid valid Input 1
   add_interface_port command_strm_port command_strm_port_data data Input [expr [get_parameter_value COMMAND_STRM_PORT_SYMBOLSPERBEAT ] * [get_parameter_value COMMAND_STRM_PORT_DATABITSPERSYMBOL ]]
	if { [get_parameter_value [string toupper command_strm_port]_DISABLESOPEOPBITSONAVST] == 0} {
      add_interface_port command_strm_port command_strm_port_endofpacket endofpacket Input 1
      add_interface_port command_strm_port command_strm_port_startofpacket startofpacket Input 1
   }


	set numErrBits [get_parameter_value [string toupper command_strm_port]_NUMERRORBITS] 
   if {$numErrBits > 0} {
		add_interface_port command_strm_port command_strm_port_error error Input $numErrBits
   }
	set numEmptyBits [get_parameter_value [string toupper command_strm_port]_NUMEMPTYBITS] 
	if {$numEmptyBits > 0} {
		add_interface_port command_strm_port command_strm_port_empty empty Input $numEmptyBits
	}


   ####################
   # Avalon-ST Packet connection point for stream co_port status_strm_port for bustype avalon_st_raw
   add_interface status_strm_port avalon_streaming source clk
   set_interface_property status_strm_port symbolsPerBeat [get_parameter_value STATUS_STRM_PORT_SYMBOLSPERBEAT ]
   set_interface_property status_strm_port dataBitsPerSymbol [get_parameter_value STATUS_STRM_PORT_DATABITSPERSYMBOL ]
   
   set_interface_property status_strm_port associatedClock clk
   
   add_interface_port status_strm_port status_strm_port_ready ready Input 1
   add_interface_port status_strm_port status_strm_port_valid valid Output 1
   add_interface_port status_strm_port status_strm_port_data data Output [expr [get_parameter_value STATUS_STRM_PORT_SYMBOLSPERBEAT ] * [get_parameter_value STATUS_STRM_PORT_DATABITSPERSYMBOL ]]
	if { [get_parameter_value [string toupper status_strm_port]_DISABLESOPEOPBITSONAVST] == 0} {
      add_interface_port status_strm_port status_strm_port_endofpacket endofpacket Output 1
      add_interface_port status_strm_port status_strm_port_startofpacket startofpacket Output 1
   }


	set numErrBits [get_parameter_value [string toupper status_strm_port]_NUMERRORBITS] 
	if {$numErrBits > 0} {
		add_interface_port status_strm_port status_strm_port_error error Output $numErrBits
	}
	set numEmptyBits [get_parameter_value [string toupper status_strm_port]_NUMEMPTYBITS] 
	if {$numEmptyBits > 0} {
		add_interface_port status_strm_port status_strm_port_empty empty Output $numEmptyBits
	}


   ####################
   # Avalon-ST Packet connection point for stream co_port trigger_strm_port for bustype avalon_st_raw
   add_interface trigger_strm_port avalon_streaming source clk
   set_interface_property trigger_strm_port symbolsPerBeat [get_parameter_value TRIGGER_STRM_PORT_SYMBOLSPERBEAT ]
   set_interface_property trigger_strm_port dataBitsPerSymbol [get_parameter_value TRIGGER_STRM_PORT_DATABITSPERSYMBOL ]
   
   set_interface_property trigger_strm_port associatedClock clk
   
   add_interface_port trigger_strm_port trigger_strm_port_ready ready Input 1
   add_interface_port trigger_strm_port trigger_strm_port_valid valid Output 1
   add_interface_port trigger_strm_port trigger_strm_port_data data Output [expr [get_parameter_value TRIGGER_STRM_PORT_SYMBOLSPERBEAT ] * [get_parameter_value TRIGGER_STRM_PORT_DATABITSPERSYMBOL ]]
	if { [get_parameter_value [string toupper trigger_strm_port]_DISABLESOPEOPBITSONAVST] == 0} {
      add_interface_port trigger_strm_port trigger_strm_port_endofpacket endofpacket Output 1
      add_interface_port trigger_strm_port trigger_strm_port_startofpacket startofpacket Output 1
   }


	set numErrBits [get_parameter_value [string toupper trigger_strm_port]_NUMERRORBITS] 
	if {$numErrBits > 0} {
		add_interface_port trigger_strm_port trigger_strm_port_error error Output $numErrBits
	}
	set numEmptyBits [get_parameter_value [string toupper trigger_strm_port]_NUMEMPTYBITS] 
	if {$numEmptyBits > 0} {
		add_interface_port trigger_strm_port trigger_strm_port_empty empty Output $numEmptyBits
	}

	send_message info "elaborate: END"
} 
# end elaborate{}

####################
# generate callback
proc generate { } {
	# generate and instance wrapper VHDL file
	set outdir [get_generation_property OUTPUT_DIRECTORY ]
	set outputname [get_generation_property OUTPUT_NAME ]

	set instFileName "${outputname}.vhd"
	
	send_message info "generate: Generating $instFileName and adding to the module"
	if {[catch {set instanceOutFile [open [file join $outdir $instFileName] w]}]} {
		send_message info "elaborate: Failed to open the file: $instFileName"
		return
	}
   source "ants_trigger_arch_module_inst.vhd.tcl"
	close $instanceOutFile
	add_file [file join $outdir $instFileName] {SYNTHESIS SIMULATION}
	send_message info "generate: END"
} 
# end generate{}
