# Copyright (c) 2012, Impulse Accelerated Technologies, Inc.
# All Rights Reserved.


#
# ants_trigger_arch_module_sw.tcl
#

# Create a new driver
create_driver ants_trigger_arch_module

# Associate driver with hardware
set_sw_property hw_class_name ants_trigger_arch_module

# The version of this driver
set_sw_property version 11.1

# setup callbacks used during BSP phases
set_sw_property callback_source_file ants_trigger_arch_module_callbacks.tcl
set_sw_property generation_callback generate_sw

# This driver may be incompatible with versions of hardware less
# than specified below. Updates to hardware and device drivers
# rendering the driver incompatible with older versions of
# hardware are noted with this property assignment.
#set_sw_property min_compatible_hw_version 10.1

# Initialize the driver in alt_sys_init()
set_sw_property auto_initialize true

# Location in generated BSP that above sources will be copied into
set_sw_property bsp_subdirectory drivers

# Set priority assignment for alt_sys_init()
# If left unspecified, driver priorities default to '1000'.
set_sw_property alt_sys_init_priority 100

# Interrupt properties:
#set_sw_property isr_preemption_supported true
#set_sw_property supported_interrupt_apis "legacy_interrupt_api enhanced_interrupt_api"

#
# Source file listings...
#

# C source files
add_sw_property c_source HAL/src/co_memory.c
add_sw_property c_source HAL/src/co_process.c
add_sw_property c_source HAL/src/co_register.c
add_sw_property c_source HAL/src/co_signal.c
add_sw_property c_source HAL/src/co_stream.c
add_sw_property c_source HAL/src/co_type.c

# Assembly source files
add_sw_property asm_source HAL/src/nios2_impc.s

# Include files
add_sw_property include_source HAL/inc/co.h
add_sw_property include_source HAL/inc/co_if_sim.h
add_sw_property include_source HAL/inc/co_math.h
add_sw_property include_source HAL/inc/co_types.h
add_sw_property include_source HAL/inc/cosim_log.h
add_sw_property include_source HAL/inc/ants_trigger_arch_module.h


# Set which OS types this driver supports:
add_sw_property supported_bsp_type HAL
#add_sw_property supported_bsp_type UCOSII

# End of file
