------------------------------------------------------------------------
-- DO NOT EDIT
-- This file was automatically generated by the Impulse C Compiler.
-- 
-- Impulse C is Copyright 2002-2015, Impulse Accelerated Technologies, Inc.
-- 
-- Stage Master is Copyright 2002-2015, Green Mountain Computing Systems, Inc.
-- 
-- All rights reserved.
------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

use work.components.all;

use work.mem_if_components.all;

entity ants_trigger_arch is
  port (
    reset : in std_ulogic;
    sclk : in std_ulogic;
    clk : in std_ulogic;
    mac_in_strm_port_en : in std_ulogic;
    mac_in_strm_port_eos : in std_ulogic;
    mac_in_strm_port_data : in std_ulogic_vector (262 downto 0);
    mac_in_strm_port_rdy : out std_ulogic;
    mac_out_strm_port_en : in std_ulogic;
    mac_out_strm_port_data : out std_ulogic_vector (262 downto 0);
    mac_out_strm_port_eos : out std_ulogic;
    mac_out_strm_port_rdy : out std_ulogic;
    command_strm_port_en : in std_ulogic;
    command_strm_port_eos : in std_ulogic;
    command_strm_port_data : in std_ulogic_vector (31 downto 0);
    command_strm_port_rdy : out std_ulogic;
    status_strm_port_en : in std_ulogic;
    status_strm_port_data : out std_ulogic_vector (31 downto 0);
    status_strm_port_eos : out std_ulogic;
    status_strm_port_rdy : out std_ulogic;
    trigger_strm_port_en : in std_ulogic;
    trigger_strm_port_data : out std_ulogic_vector (47 downto 0);
    trigger_strm_port_eos : out std_ulogic;
    trigger_strm_port_rdy : out std_ulogic);
end;

architecture structure of ants_trigger_arch is
  component ants_config_proc is
    port (
    reset : in std_ulogic;
    sclk : in std_ulogic;
    clk : in std_ulogic;
    p_cmd_strm_rdy : in std_ulogic;
    p_cmd_strm_en : inout std_ulogic;
    p_cmd_strm_eos : in std_ulogic;
    p_cmd_strm_data : in std_ulogic_vector (31 downto 0);
    p_stat_strm_rdy : in std_ulogic;
    p_stat_strm_en : inout std_ulogic;
    p_stat_strm_eos : out std_ulogic;
    p_stat_strm_data : out std_ulogic_vector (31 downto 0);
    p_MatchIPv4Dest_wr : out std_ulogic;
    p_MatchIPv4Dest_dout : out std_ulogic_vector (31 downto 0);
    p_MatchIpv4Proto_wr : out std_ulogic;
    p_MatchIpv4Proto_dout : out std_ulogic_vector (7 downto 0);
    p_MatchUdpPort_wr : out std_ulogic;
    p_MatchUdpPort_dout : out std_ulogic_vector (15 downto 0)
    );
  end component;

  component ants_filter_proc is
    port (
    reset : in std_ulogic;
    sclk : in std_ulogic;
    clk : in std_ulogic;
    p_from_mac_strm_rdy : in std_ulogic;
    p_from_mac_strm_en : inout std_ulogic;
    p_from_mac_strm_eos : in std_ulogic;
    p_from_mac_strm_data : in std_ulogic_vector (262 downto 0);
    p_to_mac_strm_rdy : in std_ulogic;
    p_to_mac_strm_en : inout std_ulogic;
    p_to_mac_strm_eos : out std_ulogic;
    p_to_mac_strm_data : out std_ulogic_vector (262 downto 0);
    p_payload_strm_rdy : in std_ulogic;
    p_payload_strm_en : inout std_ulogic;
    p_payload_strm_eos : out std_ulogic;
    p_payload_strm_data : out std_ulogic_vector (268 downto 0);
    p_MatchIpv4Proto_din : in std_ulogic_vector (7 downto 0);
    p_MatchIPv4Dest_din : in std_ulogic_vector (31 downto 0);
    p_MatchUdpPort_din : in std_ulogic_vector (15 downto 0)
    );
  end component;

  component ants_trigger_proc is
    port (
    reset : in std_ulogic;
    sclk : in std_ulogic;
    clk : in std_ulogic;
    p_payload_strm_rdy : in std_ulogic;
    p_payload_strm_en : inout std_ulogic;
    p_payload_strm_eos : in std_ulogic;
    p_payload_strm_data : in std_ulogic_vector (268 downto 0);
    p_trigger_strm_rdy : in std_ulogic;
    p_trigger_strm_en : inout std_ulogic;
    p_trigger_strm_eos : out std_ulogic;
    p_trigger_strm_data : out std_ulogic_vector (47 downto 0)
    );
  end component;

  component g_MatchIPv4Dest is
    port (
    reset : in std_ulogic;
    sclk : in std_ulogic;
    clk : in std_ulogic;
    wr0 : in std_ulogic;
    din0 : in std_ulogic_vector (31 downto 0);
    dout0 : out std_ulogic_vector (31 downto 0)
    );
  end component;

  component g_MatchIpv4Proto is
    port (
    reset : in std_ulogic;
    sclk : in std_ulogic;
    clk : in std_ulogic;
    wr0 : in std_ulogic;
    din0 : in std_ulogic_vector (7 downto 0);
    dout0 : out std_ulogic_vector (7 downto 0)
    );
  end component;

  component g_MatchUdpPort is
    port (
    reset : in std_ulogic;
    sclk : in std_ulogic;
    clk : in std_ulogic;
    wr0 : in std_ulogic;
    din0 : in std_ulogic_vector (15 downto 0);
    dout0 : out std_ulogic_vector (15 downto 0)
    );
  end component;

  signal p_ants_config_proc_cmd_strm_rdy : std_ulogic;
  signal p_ants_config_proc_cmd_strm_en : std_ulogic;
  signal p_ants_config_proc_cmd_strm_eos : std_ulogic;
  signal p_ants_config_proc_cmd_strm_data : std_ulogic_vector (31 downto 0);
  signal p_ants_config_proc_stat_strm_rdy : std_ulogic;
  signal p_ants_config_proc_stat_strm_en : std_ulogic;
  signal p_ants_config_proc_stat_strm_eos : std_ulogic;
  signal p_ants_config_proc_stat_strm_data : std_ulogic_vector (31 downto 0);
  signal p_ants_config_proc_MatchIPv4Dest_wr : std_ulogic;
  signal p_ants_config_proc_MatchIPv4Dest_dout : std_ulogic_vector (31 downto 0);
  signal p_ants_config_proc_MatchIpv4Proto_wr : std_ulogic;
  signal p_ants_config_proc_MatchIpv4Proto_dout : std_ulogic_vector (7 downto 0);
  signal p_ants_config_proc_MatchUdpPort_wr : std_ulogic;
  signal p_ants_config_proc_MatchUdpPort_dout : std_ulogic_vector (15 downto 0);
  signal p_ants_filter_proc_from_mac_strm_rdy : std_ulogic;
  signal p_ants_filter_proc_from_mac_strm_en : std_ulogic;
  signal p_ants_filter_proc_from_mac_strm_eos : std_ulogic;
  signal p_ants_filter_proc_from_mac_strm_data : std_ulogic_vector (262 downto 0);
  signal p_ants_filter_proc_to_mac_strm_rdy : std_ulogic;
  signal p_ants_filter_proc_to_mac_strm_en : std_ulogic;
  signal p_ants_filter_proc_to_mac_strm_eos : std_ulogic;
  signal p_ants_filter_proc_to_mac_strm_data : std_ulogic_vector (262 downto 0);
  signal p_ants_filter_proc_payload_strm_rdy : std_ulogic;
  signal p_ants_filter_proc_payload_strm_en : std_ulogic;
  signal p_ants_filter_proc_payload_strm_eos : std_ulogic;
  signal p_ants_filter_proc_payload_strm_data : std_ulogic_vector (268 downto 0);
  signal p_ants_filter_proc_MatchIpv4Proto_din : std_ulogic_vector (7 downto 0);
  signal p_ants_filter_proc_MatchIPv4Dest_din : std_ulogic_vector (31 downto 0);
  signal p_ants_filter_proc_MatchUdpPort_din : std_ulogic_vector (15 downto 0);
  signal p_ants_trigger_proc_payload_strm_rdy : std_ulogic;
  signal p_ants_trigger_proc_payload_strm_en : std_ulogic;
  signal p_ants_trigger_proc_payload_strm_eos : std_ulogic;
  signal p_ants_trigger_proc_payload_strm_data : std_ulogic_vector (268 downto 0);
  signal p_ants_trigger_proc_trigger_strm_rdy : std_ulogic;
  signal p_ants_trigger_proc_trigger_strm_en : std_ulogic;
  signal p_ants_trigger_proc_trigger_strm_eos : std_ulogic;
  signal p_ants_trigger_proc_trigger_strm_data : std_ulogic_vector (47 downto 0);
  signal local_reset : std_ulogic;
begin
  local_reset <= reset;

  ants_config_proc0: ants_config_proc
    port map (
      reset => local_reset,
      sclk => sclk,
      clk => clk,
      p_cmd_strm_rdy => p_ants_config_proc_cmd_strm_rdy,
      p_cmd_strm_en => p_ants_config_proc_cmd_strm_en,
      p_cmd_strm_eos => p_ants_config_proc_cmd_strm_eos,
      p_cmd_strm_data => p_ants_config_proc_cmd_strm_data,
      p_stat_strm_rdy => p_ants_config_proc_stat_strm_rdy,
      p_stat_strm_en => p_ants_config_proc_stat_strm_en,
      p_stat_strm_eos => p_ants_config_proc_stat_strm_eos,
      p_stat_strm_data => p_ants_config_proc_stat_strm_data,
      p_MatchIPv4Dest_wr => p_ants_config_proc_MatchIPv4Dest_wr,
      p_MatchIPv4Dest_dout => p_ants_config_proc_MatchIPv4Dest_dout,
      p_MatchIpv4Proto_wr => p_ants_config_proc_MatchIpv4Proto_wr,
      p_MatchIpv4Proto_dout => p_ants_config_proc_MatchIpv4Proto_dout,
      p_MatchUdpPort_wr => p_ants_config_proc_MatchUdpPort_wr,
      p_MatchUdpPort_dout => p_ants_config_proc_MatchUdpPort_dout
    );

  ants_filter_proc0: ants_filter_proc
    port map (
      reset => local_reset,
      sclk => sclk,
      clk => clk,
      p_from_mac_strm_rdy => p_ants_filter_proc_from_mac_strm_rdy,
      p_from_mac_strm_en => p_ants_filter_proc_from_mac_strm_en,
      p_from_mac_strm_eos => p_ants_filter_proc_from_mac_strm_eos,
      p_from_mac_strm_data => p_ants_filter_proc_from_mac_strm_data,
      p_to_mac_strm_rdy => p_ants_filter_proc_to_mac_strm_rdy,
      p_to_mac_strm_en => p_ants_filter_proc_to_mac_strm_en,
      p_to_mac_strm_eos => p_ants_filter_proc_to_mac_strm_eos,
      p_to_mac_strm_data => p_ants_filter_proc_to_mac_strm_data,
      p_payload_strm_rdy => p_ants_filter_proc_payload_strm_rdy,
      p_payload_strm_en => p_ants_filter_proc_payload_strm_en,
      p_payload_strm_eos => p_ants_filter_proc_payload_strm_eos,
      p_payload_strm_data => p_ants_filter_proc_payload_strm_data,
      p_MatchIpv4Proto_din => p_ants_filter_proc_MatchIpv4Proto_din,
      p_MatchIPv4Dest_din => p_ants_filter_proc_MatchIPv4Dest_din,
      p_MatchUdpPort_din => p_ants_filter_proc_MatchUdpPort_din
    );

  ants_trigger_proc0: ants_trigger_proc
    port map (
      reset => local_reset,
      sclk => sclk,
      clk => clk,
      p_payload_strm_rdy => p_ants_trigger_proc_payload_strm_rdy,
      p_payload_strm_en => p_ants_trigger_proc_payload_strm_en,
      p_payload_strm_eos => p_ants_trigger_proc_payload_strm_eos,
      p_payload_strm_data => p_ants_trigger_proc_payload_strm_data,
      p_trigger_strm_rdy => p_ants_trigger_proc_trigger_strm_rdy,
      p_trigger_strm_en => p_ants_trigger_proc_trigger_strm_en,
      p_trigger_strm_eos => p_ants_trigger_proc_trigger_strm_eos,
      p_trigger_strm_data => p_ants_trigger_proc_trigger_strm_data
    );

  MatchIPv4Dest0: g_MatchIPv4Dest
    port map (
      reset => local_reset,
      sclk => sclk,
      clk => clk,
      wr0 => p_ants_config_proc_MatchIPv4Dest_wr,
      din0 => p_ants_config_proc_MatchIPv4Dest_dout,
      dout0 => p_ants_filter_proc_MatchIPv4Dest_din
    );

  MatchIpv4Proto0: g_MatchIpv4Proto
    port map (
      reset => local_reset,
      sclk => sclk,
      clk => clk,
      wr0 => p_ants_config_proc_MatchIpv4Proto_wr,
      din0 => p_ants_config_proc_MatchIpv4Proto_dout,
      dout0 => p_ants_filter_proc_MatchIpv4Proto_din
    );

  MatchUdpPort0: g_MatchUdpPort
    port map (
      reset => local_reset,
      sclk => sclk,
      clk => clk,
      wr0 => p_ants_config_proc_MatchUdpPort_wr,
      din0 => p_ants_config_proc_MatchUdpPort_dout,
      dout0 => p_ants_filter_proc_MatchUdpPort_din
    );

  inst0: stream_wire
    generic map (
      datawidth => 263,
      addrwidth => 2
    )
    port map (
      reset => local_reset,
      clk => clk,
      input_en => mac_in_strm_port_en,
      input_rdy => mac_in_strm_port_rdy,
      input_eos => mac_in_strm_port_eos,
      input_data => mac_in_strm_port_data,
      output_en => p_ants_filter_proc_from_mac_strm_en,
      output_rdy => p_ants_filter_proc_from_mac_strm_rdy,
      output_eos => p_ants_filter_proc_from_mac_strm_eos,
      output_data => p_ants_filter_proc_from_mac_strm_data
    );

  inst1: stream_wire
    generic map (
      datawidth => 263,
      addrwidth => 2
    )
    port map (
      reset => local_reset,
      clk => clk,
      input_en => p_ants_filter_proc_to_mac_strm_en,
      input_rdy => p_ants_filter_proc_to_mac_strm_rdy,
      input_eos => p_ants_filter_proc_to_mac_strm_eos,
      input_data => p_ants_filter_proc_to_mac_strm_data,
      output_en => mac_out_strm_port_en,
      output_rdy => mac_out_strm_port_rdy,
      output_eos => mac_out_strm_port_eos,
      output_data => mac_out_strm_port_data
    );

  inst2: stream_wire
    generic map (
      datawidth => 32,
      addrwidth => 1
    )
    port map (
      reset => local_reset,
      clk => clk,
      input_en => command_strm_port_en,
      input_rdy => command_strm_port_rdy,
      input_eos => command_strm_port_eos,
      input_data => command_strm_port_data,
      output_en => p_ants_config_proc_cmd_strm_en,
      output_rdy => p_ants_config_proc_cmd_strm_rdy,
      output_eos => p_ants_config_proc_cmd_strm_eos,
      output_data => p_ants_config_proc_cmd_strm_data
    );

  inst3: stream
    generic map (
      datawidth => 32,
      addrwidth => 2
    )
    port map (
      reset => local_reset,
      clk => clk,
      input_en => p_ants_config_proc_stat_strm_en,
      input_rdy => p_ants_config_proc_stat_strm_rdy,
      input_eos => p_ants_config_proc_stat_strm_eos,
      input_data => p_ants_config_proc_stat_strm_data,
      output_en => status_strm_port_en,
      output_rdy => status_strm_port_rdy,
      output_eos => status_strm_port_eos,
      output_data => status_strm_port_data
    );

  inst4: stream_wire
    generic map (
      datawidth => 48,
      addrwidth => 1
    )
    port map (
      reset => local_reset,
      clk => clk,
      input_en => p_ants_trigger_proc_trigger_strm_en,
      input_rdy => p_ants_trigger_proc_trigger_strm_rdy,
      input_eos => p_ants_trigger_proc_trigger_strm_eos,
      input_data => p_ants_trigger_proc_trigger_strm_data,
      output_en => trigger_strm_port_en,
      output_rdy => trigger_strm_port_rdy,
      output_eos => trigger_strm_port_eos,
      output_data => trigger_strm_port_data
    );

  inst5: stream_wire
    generic map (
      datawidth => 269,
      addrwidth => 2
    )
    port map (
      reset => local_reset,
      clk => clk,
      input_en => p_ants_filter_proc_payload_strm_en,
      input_rdy => p_ants_filter_proc_payload_strm_rdy,
      input_eos => p_ants_filter_proc_payload_strm_eos,
      input_data => p_ants_filter_proc_payload_strm_data,
      output_en => p_ants_trigger_proc_payload_strm_en,
      output_rdy => p_ants_trigger_proc_payload_strm_rdy,
      output_eos => p_ants_trigger_proc_payload_strm_eos,
      output_data => p_ants_trigger_proc_payload_strm_data
    );

end;
